﻿// Provider for a best effort IntelliSense of Visual Studio 2017.
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Lib\jquery.d.ts" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\TcHmi.d.ts" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Controls\System\TcHmiControl\Source.d.ts" />

// Provider for a best effort IntelliSense of Visual Studio 2013/2015.
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Lib\jquery\jquery.js" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\TcHmi.js" />

(function (TcHmi) {

    var LocalizeValue = function (Value,ReturnWithUnit,SourceLocale,TargetLocale) {

        var localizedValue = null;
        var localizedUnit = TcHmi.Functions.getFunction('LocalizeUnitText')();

        // Calculate to mm based on source locale
        switch(SourceLocale){
            case 'en-US':
            case 'en-EN':
                localizedValue = Number(Value) / 0.0393701;
                break;
            case 'de-DE':
                localizedValue = Number(Value);
                break;
            default:
                return '';
        }

        // Calculate to target locale
        switch(TargetLocale){
            case 'en-US':
            case 'en-EN':
                localizedValue = Number(localizedValue * 0.0393701).toFixed(0);
                break;
            case 'de-DE':
                localizedValue = Number(localizedValue).toFixed(0);
                break;
            default:
                return '';
        }

        // Return value with or without unit string
        return ReturnWithUnit ? localizedValue + ' ' + localizedUnit : localizedValue;

    };
    
    TcHmi.Functions.registerFunction('LocalizeValue', LocalizeValue);
})(TcHmi);